#include "th96.h"

const is31_led PROGMEM g_is31_leds[DRIVER_LED_TOTAL] = {
/* Refer to IS31 manual for these locations
 *   driver
 *   |  R location
 *   |  |       G location
 *   |  |       |       B location
 *   |  |       |       | */
    {0, A_1,    B_1,    C_1},
    {0, A_2,    B_2,    C_2},
    {0, A_3,    B_3,    C_3},
    {0, A_4,    B_4,    C_4},
    {0, A_5,    B_5,    C_5},
    {0, A_6,    B_6,    C_6},
    {0, A_7,    B_7,    C_7},
    {0, A_8,    B_8,    C_8},
    {0, A_9,    B_9,    C_9},
    {0, A_10,   B_10,   C_10},
    {0, A_11,   B_11,   C_11},
    {0, A_12,   B_12,   C_12},
    {0, A_13,   B_13,   C_13},
    {0, A_14,   B_14,   C_14},
    {0, A_15,   B_15,   C_15},
    {0, A_16,   B_16,   C_16},

    {0, D_1,    E_1,    F_1},
    {0, D_2,    E_2,    F_2},
    {0, D_3,    E_3,    F_3},
    {0, D_4,    E_4,    F_4},
    {0, D_5,    E_5,    F_5},
    {0, D_6,    E_6,    F_6},
    {0, D_7,    E_7,    F_7},
    {0, D_8,    E_8,    F_8},
    {0, D_9,    E_9,    F_9},
    {0, D_10,   E_10,   F_10},
    {0, D_11,   E_11,   F_11},
    {0, D_12,   E_12,   F_12},
    {0, D_13,   E_13,   F_13},
    {0, D_14,   E_14,   F_14},
    {0, D_15,   E_15,   F_15},
    {0, D_16,   E_16,   F_16},

    {0, G_1,    H_1,    I_1},
    {0, G_2,    H_2,    I_2},
    {0, G_3,    H_3,    I_3},
    {0, G_4,    H_4,    I_4},
    {0, G_5,    H_5,    I_5},
    {0, G_6,    H_6,    I_6},
    {0, G_7,    H_7,    I_7},
    {0, G_8,    H_8,    I_8},
    {0, G_9,    H_9,    I_9},
    {0, G_10,   H_10,   I_10},
    {0, G_11,   H_11,   I_11},
    {0, G_12,   H_12,   I_12},
    {0, G_13,   H_13,   I_13},
    {0, G_14,   H_14,   I_14},
    {1, A_13,    B_13,    C_13},
    {1, A_14,    B_14,    C_14},
    {1, A_15,    B_15,    C_15},
    {1, A_16,    B_16,    C_16},

    {0, J_1,    K_1,    L_1},
    {0, J_2,    K_2,    L_2},
    {0, J_3,    K_3,    L_3},
    {0, J_4,    K_4,    L_4},
    {0, J_5,    K_5,    L_5},
    {0, J_6,    K_6,    L_6},
    {0, J_7,    K_7,    L_7},
    {0, J_8,    K_8,    L_8},
    {0, J_9,    K_9,    L_9},
    {0, J_10,   K_10,   L_10},
    {0, J_11,   K_11,   L_11},
    {0, J_12,   K_12,   L_12},
    {0, J_13,   K_13,   L_13},    
    {1, D_13,   E_13,   F_13},
    {1, D_14,   E_14,   F_14},
    {1, D_15,   E_15,   F_15},
    {1, D_16,   E_16,   F_16},

    {1, G_1,    H_1,    I_1},
    {1, G_2,    H_2,    I_2},
    {1, G_3,    H_3,    I_3},
    {1, G_4,    H_4,    I_4},
    {1, G_5,    H_5,    I_5},
    {1, G_6,    H_6,    I_6},
    {1, G_7,    H_7,    I_7},
    {1, G_8,    H_8,    I_8},
    {1, G_9,    H_9,    I_9},
    {1, G_10,   H_10,   I_10},
    {1, G_11,   H_11,   I_11},
    {1, G_12,   H_12,   I_12},
    {1, G_13,   H_13,   I_13},
    {1, G_14,   H_14,   I_14},
    {1, G_15,   H_15,   I_15},
    {1, G_16,   H_16,   I_16},

    {1, J_1,    K_1,    L_1},
    {1, J_2,    K_2,    L_2},
    {1, J_3,    K_3,    L_3},
    {1, J_6,    K_6,    L_6},
    {1, J_9,    K_9,    L_9},
    {1, J_10,   K_10,   L_10},
    {1, J_11,   K_11,   L_11},
    {1, J_12,   K_12,   L_12},
    {1, J_13,   K_13,   L_13},
    {1, J_14,   K_14,   L_14}, 
    {1, J_15,   K_15,   L_15},
    {1, J_16,   K_16,   L_16},

};

led_config_t g_led_config = {
	{
    //     1    2    3    4       5       6    7       8       9       10      11      12      13      14      15      16      17      18
		{  0,   1,   2,   3,      4,      5,   6,      7,      8,      9,      10,     11,     12,     13,     14,     15                    },
		{  16,  17,  18,  19,     20,     21,  22,     23,     24,     25,     26,     27,     28,     29,     30,     31                    },
		{  32,  33,  34,  35,     36,     37,  38,     39,     40,     41,     42,     43,     44,     45,     46,     47,     48,     49    },
		{  50,  51,  52,  53,     54,     55,  56,     57,     58,     59,     60,     61,     62,     63,     64,     65,     66            },
		{  67,  68,  69,  70,     71,     72,  73,     74,     75,     76,     77,     78,     79,     80,     81,     82                    },
		{  83,  84,  88,  NO_LED, NO_LED, 86,  NO_LED, NO_LED, 87,     88,     89,     90,     91,     92,     93,     94                    }
	},
	{
    //    1        2        3        4        5        6        7        8        9        10        11        12        13        14        15        16        17        18
		{0,0},  {11,0},  {22, 0}, {33, 0}, {44, 0}, {55,0},  {66, 0}, {77, 0}, {88, 0}, {99, 0}, {110, 0}, {121, 0}, {132, 0}, {143, 0}, {154, 0}, {165, 0}, 
	    {0,13}, {11,13}, {22,13}, {33,13}, {44,13}, {55,13}, {66,13}, {77,13}, {88,13}, {99,13}, {110,13}, {121,13}, {132,13}, {143,13}, {154,13}, {165,13},          
	    {0,26}, {11,26}, {22,26}, {33,26}, {44,26}, {55,26}, {66,26}, {77,26}, {88,26}, {99,26}, {110,26}, {121,26}, {132,26}, {143,26}, {154,26}, {165,26}, {176,26}, {187,26},          
	    {0,39}, {11,39}, {22,39}, {33,39}, {44,39}, {55,39}, {66,39}, {77,39}, {88,39}, {99,39}, {110,39}, {121,39}, {132,39}, {143,39}, {154,39}, {165,39}, {176,39},          
	    {0,52}, {11,52}, {22,52}, {33,52}, {44,52}, {55,52}, {66,52}, {77,52}, {88,52}, {99,52}, {110,52}, {121,52}, {132,52}, {143,52}, {154,52}, {165,52},
	    {0,64}, {11,64}, {22,64},                   {55,64},                   {88,64}, {99,64}, {110,64}, {121,64}, {132,64}, {143,64}, {154,64}, {165,64}, 
	},
	{
    //  1     2     3     4     5     6     7     8     9     10    11    12    13    14    15    16    17    18
		4,	  4,	4,	  4,	4,	  4,	4,	  4,	4,	  4,	4,	  4,	4,	  4,	4,	  4,
		4,	  4,	4,	  4,	4,	  4,	4,	  4,	4,	  4,	4,	  4,	4,	  4,	4,	  4,    
		4,	  4,	4,	  4,	4,	  4,	4,	  4,	4,	  4,	4,	  4,	4,	  4,	4,	  4,    4,    4,
		4,	  4,	4,	  4,	4,	  4,	4,	  4,	4,	  4,	4,	  4,	4,	  4,	4,	  4,    4,
		4,	  4,	4,	  4,	4,	  4,	4,	  4,	4,	  4,	4,	  4,	4,	  4,	4,    4,
		4,	  4,	4,				  4,				4,	  4,	4,	  4,	4,	  4,	4,    4,

	}
};
